/*
-------------------------------------------------------------------------------
                                I   M   L   I   B
				       1.1
-------------------------------------------------------------------------------

This software is Copyright (C) 1998 By The Rasterman (Carsten Haitzler). I
accept no responsability for anythign this software may or may not do to
your system - you use it completely at your own risk. This software comes
under the LGPL and GPL licences. The library itself is LGPL (all software in
Imlib and gdk_imlib directories) see the COPYING and COPYING.LIB files for
full legal details.
*/

/*****************************************************************************/
/*  CHANGES:                                                                 */
/*           Wednesday March 18 1998, removed parts of the code that allowed */
/*           for image processing with the help of external programs         */
/*  	     Sun Apr 19 03:40:24 EDT 1998 removed EIM, tons of unnecessary */
/*  	    routines
/*****************************************************************************/


#include "gdk_imlib.h"
#include "gdk_imlib_private.h"

#ifdef HAVE_LIBJPEG
	#include <jpeglib.h>
#endif

#ifdef HAVE_LIBPNG
	#include <png.h>
#endif

#ifdef HAVE_LIBGIF
	#include <gif_lib.h>
#endif

void _SplitID(char *file, char *id)
{
   int len;
   int i,j,k;
   
   len=strlen(file);
   k=0;
   i=len-1;
   if (i<0) 
     {
	id[0]=0;
	return;
     }
   while ((file[i]!=':')&&(i>=0)) i--;
   if (i<0) id[0]=0;
   else
     {
	for (j=i+1;j<len;j++)
	  {
	     id[k++]=(char)file[j];
	  }
	id[k]=0;
	file[i]=0;
     }
}

void _GetExtension(char *file, char *ext)
{
   int len;
   int i,j,k;
   
   len=strlen(file);
   k=0;
   i=len-1;
   if (i<0) 
     {
	ext[0]=0;
	return;
     }
   while ((file[i]!='.')&&(i>=0)) i--;
   if (i<0) ext[0]=0;
   else
     {
	for (j=i+1;j<len;j++)
	  {
	     ext[k++]=(char)tolower(file[j]);
	  }
	ext[k]=0;
     }
}

#ifdef HAVE_LIBJPEG
unsigned char *_LoadJPEG(FILE *f, int *w, int *h)
{
   struct jpeg_decompress_struct cinfo;
   struct jpeg_error_mgr jerr;
   unsigned char *data,*line[16],*ptr;
   int x,y,i;
   
   cinfo.err = jpeg_std_error(&jerr);
   jpeg_create_decompress(&cinfo);
   jpeg_stdio_src(&cinfo,f);
   jpeg_read_header(&cinfo,TRUE);
   cinfo.do_fancy_upsampling=FALSE;
   cinfo.do_block_smoothing=FALSE;
   jpeg_start_decompress(&cinfo);
   *w=cinfo.output_width;
   *h=cinfo.output_height;
   data=malloc(*w**h*3);
   if (!data)
     {
	jpeg_destroy_decompress(&cinfo);
	return NULL;
     }
   ptr=data;
   if (cinfo.output_components==3)
     {
	for (y=0;y<*h;y+=cinfo.rec_outbuf_height)
	  {
	     for(i=0;i<cinfo.rec_outbuf_height;i++)
	       {
		  line[i]=ptr;ptr+=*w*3;
	       }
	     jpeg_read_scanlines(&cinfo,line,cinfo.rec_outbuf_height);
	  }
     }
   else if (cinfo.output_components==1)
     {
	for(i=0;i<cinfo.rec_outbuf_height;i++)
	  line[i]=malloc(*w);
	for (y=0;y<*h;y+=cinfo.rec_outbuf_height)
	  {
	     jpeg_read_scanlines(&cinfo,line,cinfo.rec_outbuf_height);
	     for(i=0;i<cinfo.rec_outbuf_height;i++)
	       {
		  for(x=0;x<*w;x++)
		    {
		       *ptr++=line[i][x];*ptr++=line[i][x];*ptr++=line[i][x];
		    }
	       }
	  }
	for(i=0;i<cinfo.rec_outbuf_height;i++)
	  free(line[i]);
     }
   jpeg_finish_decompress(&cinfo);
   jpeg_destroy_decompress(&cinfo);
   return data;
}
#endif

#ifdef HAVE_LIBPNG
unsigned char *_LoadPNG(FILE *f, int *w, int *h, int *t)
{
   png_structp png_ptr;
   png_infop info_ptr;
   unsigned char *data,*ptr,**lines,*ptr2,r,g,b,a;
   int i,x,y;
   int transp;
   
   /* Init PNG Reader */
   transp=0;
   png_ptr=png_create_read_struct(PNG_LIBPNG_VER_STRING,NULL,NULL,NULL);
   if (!png_ptr) return NULL;
   info_ptr=png_create_info_struct(png_ptr);
   if (!info_ptr)
     {
	png_destroy_read_struct(&png_ptr,NULL,NULL);
	return NULL;
     }
   if (setjmp(png_ptr->jmpbuf))
     {
	png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
	return NULL;
     }
   if (info_ptr->color_type==PNG_COLOR_TYPE_RGB_ALPHA)
     {
	png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
	return NULL;
     }
   png_init_io(png_ptr,f);
   /* Read Header */
   png_read_info(png_ptr,info_ptr);
   /* Setup Translators */
   if (info_ptr->color_type==PNG_COLOR_TYPE_PALETTE) png_set_expand(png_ptr);
   if (info_ptr->color_type==PNG_COLOR_TYPE_GRAY) png_set_expand(png_ptr);
   if (info_ptr->bit_depth==16) png_set_strip_16(png_ptr);
   png_set_filler(png_ptr, 0xff, PNG_FILLER_AFTER);
   *w=info_ptr->width;
   *h=info_ptr->height;
   data=malloc(*w**h*3);
   if (!data)
     {
	png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
	return NULL;
     }
   lines=(unsigned char **)malloc(*h*sizeof(unsigned char *));
   for (i=0;i<*h;i++) lines[i]=malloc(*w*(sizeof(unsigned char)*4));
   png_read_image(png_ptr,lines);
   png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
   ptr=data;
   for(y=0;y<*h;y++)
     {
	ptr2=lines[y];
	for(x=0;x<*w;x++)
	  {
	     r=*ptr2++;g=*ptr2++;b=*ptr2++;a=*ptr2++;
	     if (a<128)
	       {
		  *ptr++=255;*ptr++=0;*ptr++=255;
		  transp=1;
	       }
	     else
	       {
		  if ((r==255)&&(g==0)&&(b==255)) r=254;
		  *ptr++=r;*ptr++=g;*ptr++=b;
	       }
	  }
     }
   for (i=0;i<*h;i++) free(lines[i]);
   free(lines);
   if (transp) printf("TRANSP\n");
   *t=transp;
   return data;
}
#endif

#ifdef HAVE_LIBGIF
unsigned char *_LoadGIF(char *f, int *w, int *h, int *t)
{
   unsigned char *data,*ptr;
   GifFileType *gif;
   GifRowType *rows;
   GifRecordType rec;
   ColorMapObject *cmap;
   int i,j,done,bg,csize,r,g,b;
   int intoffset[]={0,4,2,1};
   int intjump[]={8,8,4,2};
   int istransp,transp;
   
   done=0;istransp=0;
   gif=DGifOpenFileName(f);
   if (!gif) return NULL;
   do
     {
	DGifGetRecordType(gif,&rec);
	if ((rec==IMAGE_DESC_RECORD_TYPE)&&(!done))
	  {
	     DGifGetImageDesc(gif);
	     *w=gif->Image.Width;*h=gif->Image.Height;
	     rows=malloc(*h*sizeof(GifRowType *));
	     if (!rows) 
	       {
		  DGifCloseFile(gif);
		  return NULL;
	       }
	     data=malloc(*w**h*3);
	     if (!data) 
	       {
		  DGifCloseFile(gif);
		  free(rows);
		  return NULL;
	       }
	     for(i=0;i<*h;i++) rows[i]=NULL;
	     for(i=0;i<*h;i++) 
	       {
		  rows[i]=malloc(*w*sizeof(GifPixelType));
		  if (!rows[i])
		    {
		       DGifCloseFile(gif);
		       for(i=0;i<*h;i++) if (rows[i]) free(rows[i]);
		       free(rows);
		       free(data);
		       return NULL;
		    }
	       }
	     if (gif->Image.Interlace)
	       {
		  for(i=0;i<4;i++)
		    {
		       for(j=intoffset[i];j<*h;j+=intjump[i]) DGifGetLine(gif,rows[j],*w);
		    }
	       }
	     else
	       {
		  for(i=0;i<*h;i++) DGifGetLine(gif,rows[i],*w);
	       }
	     done=1;
	  }
	else if (rec==EXTENSION_RECORD_TYPE)
	  {
	     int         ext_code;
	     GifByteType *ext;
	     
	     DGifGetExtension(gif,&ext_code,&ext);
	     if (ext)
	       {
		  if ((ext[1]&1))
		    {
		       istransp=1;
		       transp=(int)ext[4];
		    }
	       }
	     do 
	       {
		  DGifGetExtensionNext(gif,&ext);
	       } while(ext);
	  }
     } while (rec!=TERMINATE_RECORD_TYPE);
   bg=gif->SBackGroundColor;
   cmap=(gif->Image.ColorMap?gif->Image.ColorMap:gif->SColorMap);
   csize=cmap->ColorCount;
   ptr=data;
   if (!istransp)
     {
	for(i=0;i<*h;i++)
	  {
	     for(j=0;j<*w;j++)
	       {
		  r=cmap->Colors[rows[i][j]].Red;
		  g=cmap->Colors[rows[i][j]].Green;
		  b=cmap->Colors[rows[i][j]].Blue;
		  *ptr++=r;*ptr++=g;*ptr++=b;
	       }
	  }
     }
   else
     {
	for(i=0;i<*h;i++)
	  {
	     for(j=0;j<*w;j++)
	       {
		  if (rows[i][j]==transp)
		    {
		       *ptr++=255;*ptr++=0;*ptr++=255;
		    }
		  else
		    {
		       r=cmap->Colors[rows[i][j]].Red;
		       g=cmap->Colors[rows[i][j]].Green;
		       b=cmap->Colors[rows[i][j]].Blue;
		       if ((r==255)&&(g==0)&&(b==255)) r=254;
		       *ptr++=r;*ptr++=g;*ptr++=b;
		    }
	       }
	  }
     }
   DGifCloseFile(gif);
   for(i=0;i<*h;i++) free(rows[i]);
   free(rows);
   *t=istransp;
   return data;
}
#endif

unsigned char *_LoadXPM(char *f, int *w, int *h, int *t)
{
   FILE *file;
   unsigned char *data,*ptr;
   int pc,c,i,cmap_size,cpp,comment,j,transp,eol,k;
   char s[1024];
   XColor xcol;
   struct _cmap
     {
	char str[8];
	char transp;
	int r,g,b;
     } *cmap;
   int lookup[256][256];
   
   transp=0;
   file=fopen(f,"r");
   if (!file) return NULL;

   c=' ';comment=0;
   while((c!='"')||(comment))
     {
	pc=c;c=fgetc(file);
	if ((pc=='/')&&(c=='*')) comment=1;
	else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
     }
   
   /* Read Header */
   c=fgetc(file);
   while (isspace(c)) c=fgetc(file);
   i=0;do {s[i++]=c;c=fgetc(file);} while (isdigit(c));
   s[i]=0;*w=atoi(s); while (isspace(c)) c=fgetc(file);
   i=0;do {s[i++]=c;c=fgetc(file);} while (isdigit(c));
   s[i]=0;*h=atoi(s); while (isspace(c)) c=fgetc(file);
   i=0;do {s[i++]=c;c=fgetc(file);} while (isdigit(c));
   s[i]=0;cmap_size=atoi(s); while (isspace(c)) c=fgetc(file);
   i=0;do {s[i++]=c;c=fgetc(file);} while (isdigit(c));
   s[i]=0;cpp=atoi(s); while (isspace(c)) c=fgetc(file);
   c=' ';comment=0;
   while((c!='"')||(comment))
     {
	pc=c;c=fgetc(file);
	if ((pc=='/')&&(c=='*')) comment=1;
	else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
     }
   
   /* Read Colormap */
   cmap=malloc(cmap_size*sizeof(struct _cmap));
   for(k=0;k<cmap_size;k++)
     {
	cmap[k].transp=0;
	for(j=0;j<cpp;j++)
	  {
	     c=fgetc(file);
	     cmap[k].str[j]=c;
	  }
	cmap[k].str[j]=0;
	eol=0;
	while (!eol)
	  {
	     c=fgetc(file);
	     while (isspace(c)) c=fgetc(file);
	     if (c=='c')
	       {
		  c=fgetc(file);
		  while (isspace(c)) c=fgetc(file);
		  i=0;do {s[i++]=c;c=fgetc(file);} while (!isspace(c)&&c!='"');
		  s[i]=0;
		  if (!strcasecmp(s,"None")) 
		    {
		       transp=1;
		       cmap[k].transp=1;
		    }
		  else 
		    {
		       XParseColor(id->x.disp,id->x.root_cmap,s,&xcol);
		       cmap[k].r=xcol.red>>8;
		       cmap[k].g=xcol.green>>8;
		       cmap[k].b=xcol.blue>>8;
		       if ((cmap[k].r==255)&&(cmap[k].g==0)&&(cmap[k].b==255))
			 cmap[k].r=254;
		    }
		  if (c=='"') eol=1;
	       }
	     else if (c=='s')
	       {
		  c=fgetc(file);
		  while (isspace(c)) c=fgetc(file);
		  i=0;do {s[i++]=c;c=fgetc(file);} while (!isspace(c)&&c!='"');
		  s[i]=0;
		  if (!strcasecmp(s,"None")) 
		    {
		       transp=1;
		       cmap[k].transp=1;
		    }
		  if (c=='"') eol=1;
	       }
	     else if (c=='m')
	       {
		  c=fgetc(file);
		  while (isspace(c)) c=fgetc(file);
		  i=0;do {s[i++]=c;c=fgetc(file);} while (!isspace(c)&&c!='"');
		  s[i]=0;
		  if (c=='"') eol=1;
	       }
	  }
	c=fgetc(file);
	c=' ';comment=0;
	while((c!='"')||(comment))
	  {
	     pc=c;c=fgetc(file);
	     if ((pc=='/')&&(c=='*')) comment=1;
	     else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
	  }
     }

   /* Read Image Data */
   data=malloc(*w**h*3);
   if ((!data)||(cpp>2))
     {
	fclose(file);
	free(cmap);
	return NULL;
     }
   ptr=data;
   if (transp)
     {
	if (cpp==1)
	  {
	     for(i=0;i<cmap_size;i++)
	       lookup[cmap[i].str[0]][0]=i;
	     for (j=0;j<*h;j++)
	       {
		  for(i=0;i<*w;i++)
		    {
		       c=fgetc(file);
		       if (cmap[lookup[c][0]].transp)
			 {
			    *ptr++=255;*ptr++=0;*ptr++=255;
			 }
		       else
			 {
			    *ptr++=(unsigned char)cmap[lookup[c][0]].r;
			    *ptr++=(unsigned char)cmap[lookup[c][0]].g;
			    *ptr++=(unsigned char)cmap[lookup[c][0]].b;
			 }
		    }
		  c=fgetc(file);
		  c=' ';comment=0;
		  if (j<(*h-1))
		    {
		       while((c!='"')||(comment))
			 {
			    pc=c;c=fgetc(file);
			    if ((pc=='/')&&(c=='*')) comment=1;
			    else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
			 }
		    }
	       }
	  }
	else 
	  {
	     for(i=0;i<cmap_size;i++)
	       lookup[cmap[i].str[0]][cmap[i].str[1]]=i;
	     for (j=0;j<*h;j++)
	       {
		  for(i=0;i<*w;i++)
		    {
		       c=fgetc(file);
		       pc=fgetc(file);
		       if (cmap[lookup[c][pc]].transp)
			 {
			    *ptr++=255;*ptr++=0;*ptr++=255;
			 }
		       else
			 {
			    *ptr++=(unsigned char)cmap[lookup[c][pc]].r;
			    *ptr++=(unsigned char)cmap[lookup[c][pc]].g;
			    *ptr++=(unsigned char)cmap[lookup[c][pc]].b;
			 }
		    }
		  c=fgetc(file);
		  c=' ';comment=0;
		  if (j<(*h-1))
		    {
		       while((c!='"')||(comment))
			 {
			    pc=c;c=fgetc(file);
			    if ((pc=='/')&&(c=='*')) comment=1;
			    else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
			 }
		    }
	       }
	  }
     }
   else
     {
	if (cpp==1)
	  {
	     for(i=0;i<cmap_size;i++)
	       lookup[cmap[i].str[0]][0]=i;
	     for (j=0;j<*h;j++)
	       {
		  for(i=0;i<*w;i++)
		    {
		       c=fgetc(file);
		       *ptr++=(unsigned char)cmap[lookup[c][0]].r;
		       *ptr++=(unsigned char)cmap[lookup[c][0]].g;
		       *ptr++=(unsigned char)cmap[lookup[c][0]].b;
		    }
		  c=fgetc(file);
		  c=' ';comment=0;
		  if (j<(*h-1))
		    {
		       while((c!='"')||(comment))
			 {
			    pc=c;c=fgetc(file);
			    if ((pc=='/')&&(c=='*')) comment=1;
			    else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
			 }
		    }
	       }
	  }
	else 
	  {
	     for(i=0;i<cmap_size;i++)
	       lookup[cmap[i].str[0]][cmap[i].str[1]]=i;
	     for (j=0;j<*h;j++)
	       {
		  for(i=0;i<*w;i++)
		    {
		       c=fgetc(file);
		       pc=fgetc(file);
		       *ptr++=(unsigned char)cmap[lookup[c][pc]].r;
		       *ptr++=(unsigned char)cmap[lookup[c][pc]].g;
		       *ptr++=(unsigned char)cmap[lookup[c][pc]].b;
		    }
		  c=fgetc(file);
		  c=' ';comment=0;
		  if (j<(*h-1))
		    {
		       while((c!='"')||(comment))
			 {
			    pc=c;c=fgetc(file);
			    if ((pc=='/')&&(c=='*')) comment=1;
			    else if ((pc=='*')&&(c=='/')&&(comment)) comment=0;
			 }
		    }
	       }
	  }
     }
   fclose(file);
   free(cmap);
   if (transp) *t=1;
   else *t=0;
   return data;
}

#ifdef HAVE_LIBJPEG
int isjpeg(char *file)
{
   FILE *f;
   unsigned char buf[8];
   
   f=fopen(file,"rb");
   if (!f) return 0;
   fread(buf,1,2,f);
   fclose(f);
   if ((buf[0]==0xff)&&(buf[1]==0xd8)) return 1;
   return 0;
}
#endif

#ifdef HAVE_LIBPNG
int ispng(char *file)
{
   FILE *f;
   unsigned char buf[8];
   
   f=fopen(file,"rb");
   if (!f) return 0;
   fread(buf,1,8,f);
   fclose(f);
   return (int)png_check_sig(buf,8);
}

#endif

#ifdef HAVE_LIBGIF
int isgif(char *file)
{
   FILE *f;
   char buf[8];
   
   f=fopen(file,"rb");
   if (!f) return 0;
   fread(buf,1,4,f);
   fclose(f);
   buf[4]=0;
   if (!strcmp("GIF8",buf)) return 1;
   return 0;
}
#endif

int isxpm(char *file)
{
   FILE *f;
   char buf[11];
   
   f=fopen(file,"rb");
   if (!f) return 0;
   fread(buf,1,9,f);
   fclose(f);
   buf[9]=0;
   if (!strcmp("/* XPM */",buf)) return 1;
   return 0;
}

GdkImlibImage *gdk_imlib_load_image(char *file)
{
   int w, h;

   int needs_conv = 1;
   unsigned char *data;
   GdkImlibImage *im;
   char s[4096];
   char fil[4096];
   char iden[4096];
   char cmd[4096];
   FILE *p;
   int eim;
   int fmt;
   int trans;
   
   eim=0;fmt=0;p=NULL;
   data=NULL;
   strcpy(fil,file);
   _SplitID(fil,iden);_GetExtension(fil,s);

#ifdef HAVE_LIBJPEG
   if (isjpeg(fil)) 
     {
	needs_conv = 0;
	fmt=2;
     }
#else
   if (isxp(fil))
     {
	needs_conv=0;fmt=5;
     }
#endif
   else if (isxpm(fil)) 
     {
	needs_conv=0;fmt=5;
     }

#ifdef HAVE_LIBPNG
   else if (ispng(fil))  
     {
	needs_conv = 0;
	fmt=1;
     }
#endif

#ifdef HAVE_LIBGIF	
   else if (isgif(fil))  
     {
	needs_conv = 0;
	fmt=4;
     }
#endif

   if ((fmt==2)||(fmt==1)||(fmt==0)) p=fopen(fil,"rb");
   trans=0;
	switch(fmt)
	  {
	   case 5:
	     data=_LoadXPM(fil,&w,&h,&trans);
	     if (!data) printf("Failed! Fallback!\n");
	     break;
#ifdef HAVE_LIBGIF
	   case 4:
	     data=_LoadGIF(fil,&w,&h,&trans);
	     if (!data) printf("Failed! Fallback!\n");
	     break;
#endif
#ifdef HAVE_LIBJPEG
	   case 2:
	     if (p) data=_LoadJPEG(p,&w,&h);
	     if (!data) printf("Failed! Fallback!\n");
	     break;
#endif
#ifdef HAVE_LIBPNG
	   case 1:
	     if (p) data=_LoadPNG(p,&w,&h,&trans);
	     if (!data) printf("Failed! Fallback!\n");
	     break;
#endif
	   default:
	     printf ("Format not known");
	     break;
	     break;
   }

   if ((p)&&(!needs_conv)) fclose(p);
   else if (p) pclose(p);
   if ((!eim)&&(!data)) 
     {
	fprintf(stderr,"ImLib ERROR: Cannot load image: %s\nAll fallbacks failed.\n",fil);
	return NULL;
     }
   im=(GdkImlibImage *)malloc(sizeof(GdkImlibImage));
   if (!im)
     {
	fprintf(stderr,"Imlib ERROR: Cannot allocate RAM for image data\n");
	return NULL;
     }
   im->height = h;
   im->width = w;
   im->alpha_data=NULL;
   if (trans)
     {
	im->shape_color.r=255;
	im->shape_color.g=0;
	im->shape_color.b=255;
     }
   else
     {
	im->shape_color.r=-1;
	im->shape_color.g=-1;
	im->shape_color.b=-1;
     }
   im->border.left=0;im->border.right=0;im->border.top=0;im->border.bottom=0;
   im->cache=1;im->rgb_data=data;im->rgb_width=w;im->rgb_height=h;
   im->pixmap=NULL;im->shape_mask=NULL;
   im->mod.gamma=id->mod.gamma;
   im->mod.brightness=id->mod.brightness;
   im->mod.contrast=id->mod.contrast;
   im->rmod.gamma=id->rmod.gamma;
   im->rmod.brightness=id->rmod.brightness;
   im->rmod.contrast=id->rmod.contrast;
   im->gmod.gamma=id->gmod.gamma;
   im->gmod.brightness=id->gmod.brightness;
   im->gmod.contrast=id->gmod.contrast;
   im->bmod.gamma=id->bmod.gamma;
   im->bmod.brightness=id->bmod.brightness;
   im->bmod.contrast=id->bmod.contrast;
   im->filename=malloc(strlen(file)+1);
   if (im->filename)
     strcpy(im->filename,file);
   calc_map_tables(im);
   return im;
}
